#include <exception> // ANSI C++
#include <new> // ANSI C++
#include <cstdlib> // ANSI C++
#include <cstdio> // es como el import java.io.*;

typedef char L_int8;
typedef short L_int16;
typedef long L_int32;
typedef unsigned char L_uint8;
typedef unsigned short L_uint16;
typedef unsigned long L_uint32;

using namespace std;

// Clase para entender estructura interna de los archivos BMP
class L_BMPheaderInfo
{
public:
	//header (14B)
	L_uint8 _B; // 0
	L_uint8 _M; // 1
	L_uint32 _tamArch; //2-5
	L_uint16 _reserv1; //6-7
	L_uint16 _reserv2; //8-9
	L_uint32 _offsetDatos;  //10-13 //Ah-Dh
	// info (40B)
	L_uint32 tamHeader; //14-17 // Eh-11h
	L_int32 ancho; //18-21 //12h-15h
	L_int32 alto;  //22-25 //16h-19h
	L_uint16 planos; //26-27 //1Ah-1Bh
	L_uint16 bits;   //28-29 //1Ch-1Dh
	L_uint32 compr;  //30-33 //1Eh-21h
	L_uint32 tamImagen; //34-37 //22h-25h
	L_int32 pixPorMetroX; //38-41 //26h-29h
	L_int32 pixPorMetroY; //42-45 //2Ah-2Dh
	L_uint32 nColores; //46-49 //30h-33h
	L_uint32 nColoresImp; //50-53 //34h-37h
	// extra
	long Espblanco;
	L_BMPheaderInfo()
	{
		_B='B';
		_M='M';
		_tamArch=0;
		_reserv1=0;
		_reserv2=0;
		_offsetDatos=54;
		tamHeader=40;
		ancho=0;
		alto=0;
		planos=1;
		bits=24;
		compr=0;
		tamImagen=0;
		pixPorMetroX=196;
		pixPorMetroY=196;
		nColores=0;
		nColoresImp=0;
		Espblanco=0;
	}
	bool fijaTam(L_uint32 Ancho, L_uint32 Alto, L_uint16 Bits)
	{
		long tamMemo;
		long tamLinea;
		bits=Bits;
		ancho=Ancho;
		alto=Alto;

		if (bits!=16 && bits!=24 && bits!=32)
			return false;
		tamLinea=(ancho*bits+7)/8;
		tamLinea=(tamLinea+3)/4*4;
		tamImagen=tamLinea*alto;

		tamMemo=ancho*(bits/8)*alto;
		Espblanco=(tamImagen-tamMemo)/alto;
		_tamArch=_offsetDatos+tamImagen;
		return true;
	}

	void guardaEn(FILE *fp)
	{
		fwrite(&_B,sizeof(_B),1,fp);
		fwrite(&_M,sizeof(_M),1,fp);
		fwrite(&_tamArch,sizeof(_tamArch),1,fp);
		fwrite(&_reserv1,sizeof(_reserv1),1,fp);
		fwrite(&_reserv2,sizeof(_reserv2),1,fp);
		fwrite(&_offsetDatos,sizeof(_offsetDatos),1,fp);
		//
		fwrite(&tamHeader,sizeof(tamHeader),1,fp);
		fwrite(&ancho,sizeof(ancho),1,fp);
		fwrite(&alto,sizeof(alto),1,fp);
		fwrite(&planos,sizeof(planos),1,fp);
		fwrite(&bits,sizeof(bits),1,fp);
		fwrite(&compr,sizeof(compr),1,fp);
		fwrite(&tamImagen,sizeof(tamImagen),1,fp);
		fwrite(&pixPorMetroX,sizeof(pixPorMetroX),1,fp);
		fwrite(&pixPorMetroY,sizeof(pixPorMetroY),1,fp);
		fwrite(&nColores,sizeof(nColores),1,fp);
		fwrite(&nColoresImp,sizeof(nColoresImp),1,fp);
	}

	bool leeDe(FILE *fp)
	{
		long tamMemo;
		if (fread(&_B,sizeof(_B),1,fp)==0)
			return false;
		if (_B!='B')
			return false;
		if (fread(&_M,sizeof(_M),1,fp)==0)
			return false;
		if (_M!='M')
			return false;
		fread(&_tamArch,sizeof(_tamArch),1,fp);
		fread(&_reserv1,sizeof(_reserv1),1,fp);
		fread(&_reserv2,sizeof(_reserv2),1,fp);
		fread(&_offsetDatos,sizeof(_offsetDatos),1,fp);
		//
		fread(&tamHeader,sizeof(tamHeader),1,fp);
		fread(&ancho,sizeof(ancho),1,fp);
		fread(&alto,sizeof(alto),1,fp);
		fread(&planos,sizeof(planos),1,fp);
		fread(&bits,sizeof(bits),1,fp);
		fread(&compr,sizeof(compr),1,fp);
		fread(&tamImagen,sizeof(tamImagen),1,fp);
		fread(&pixPorMetroX,sizeof(pixPorMetroX),1,fp);
		fread(&pixPorMetroY,sizeof(pixPorMetroY),1,fp);
		fread(&nColores,sizeof(nColores),1,fp);
		fread(&nColoresImp,sizeof(nColoresImp),1,fp);
		if (bits!=16 && bits!=24 && bits!=32)
			return false;
		tamMemo=ancho*(bits/8)*alto;
		Espblanco=(tamImagen-tamMemo)/alto;
		return true;
	}
	~L_BMPheaderInfo() {}
};

template <class T> T** L_new2d(int lx0, int ly0)// throws ((std::bad_alloc)) //! Pide memoria bidimensional
{
	int i;
    T ** im;
	try{
		im=new T*[lx0]; // lanza std::bad_alloc
		if (im==NULL) throw std::bad_alloc();
		try
		{
			im[0]=new T[lx0*ly0];
			if (im[0]==NULL) throw std::bad_alloc();
			for (i=1; i<lx0; i++)
			{
				im[i]=im[0]+ly0*i;
			}
		}
		catch (std::bad_alloc &)
		{
			delete[] im;
			throw;
		}
	}
	catch (std::bad_alloc &)
	{
		im=NULL;
		throw;
	}
	return im;
}

template <class T> void L_delete2d(T **im)// throws(()) //! Destruye memoria bidimensional
{
	delete[] im[0];
	delete[] im;
}
template <class T> T*** L_new3d(int lx0, int ly0, int lz0)// throws ((std::bad_alloc)) //! Pide memoria tridimensional
{
    int i;
	T ***im;
	try
	{
		im=new T**[lx0];
		if (im==NULL) throw std::bad_alloc();
		try
		{
			im[0]=new T*[lx0*ly0];
			if (im[0]==NULL) throw std::bad_alloc();
			try
			{
				im[0][0]=new T[lx0*ly0*lz0];
				if (im[0][0]==NULL) throw std::bad_alloc();
				for (i=1; i<lx0*ly0; i++)
				{
					im[0][i]=&im[0][0][0]+lz0*i;
				}
				for (i=1; i<lx0; i++)
					im[i]=&im[0][0]+i*ly0;
			}
			catch(std::bad_alloc &)
			{
				delete[] im[0];
				throw;
			}
		}
		catch(std::bad_alloc &)
		{
			delete[] im;
			throw;
		}
	}
	catch(std::bad_alloc &)
	{
		im=NULL;
		throw;
	}
    return im;
}
template <class T> void L_delete3d(T ***im)// throws(()) //! Destruye memoria tridimensional
{
   	delete[] im[0][0];
	delete[] im[0];
	delete[] im;
}


// Clase para imagen en color. Aqui hay que leer el archivo .bmp desde cero
class ImagenRGB
{
public:
    int *** pix;
	int lx;
	int ly;

	ImagenRGB() {this->pix=NULL; lx=0; ly=0;}
	
	ImagenRGB(int lx, int ly)
	{
		this->pix=NULL;
		reconstruye(lx, ly);
	}

	ImagenRGB(const char *nombreArchivo)
	{
		leeBMP(nombreArchivo);
	}

	void reconstruye(int lx, int ly)
	{
		this->lx=lx;
		this->ly=ly;
		if (this->pix!=NULL)
			L_delete3d<int>(pix);
		this->pix=L_new3d<int>(lx,ly,3);
	}

	int leeBMP(const char *nombre)
	{
		FILE *fp;
		L_BMPheaderInfo inf;
		struct { unsigned int b:5;unsigned int g:5;unsigned int r:5;unsigned int z:1; } rgb16;
		int i, j;

		fp=fopen(nombre,"rb");
		if (fp==NULL)
			return 0;
		if (inf.leeDe(fp)==false)
			{fclose(fp); return 0;}
		reconstruye(inf.ancho, inf.alto);
		fseek(fp, inf._offsetDatos, SEEK_SET);

		if (inf.bits==16)
		{
			for (j=ly-1; j>=0; j--)
			{
				for (i=0; i<lx; i++)
				{
					fread(&rgb16,sizeof(rgb16),1,fp);
					pix[i][j][0]=((int)rgb16.r);
					pix[i][j][1]=((int)rgb16.g);
					pix[i][j][2]=((int)rgb16.b);
				}
				fseek(fp,inf.Espblanco,SEEK_CUR);
			}
		}

		else if (inf.bits==24)
		{
			for (j=ly-1; j>=0; j--)
			{
				for (i=0; i<lx; i++)
				{
					pix[i][j][2]=((int)getc(fp));
					pix[i][j][1]=((int)getc(fp));
					pix[i][j][0]=((int)getc(fp));
				}
				fseek(fp,inf.Espblanco,SEEK_CUR);
			}
		}

		else if (inf.bits==32)
		{
			for (j=ly-1; j>=0; j--)
			{
				for (i=0; i<lx; i++)
				{
					pix[i][j][2]=((int)getc(fp));
					pix[i][j][1]=((int)getc(fp));
					pix[i][j][0]=((int)getc(fp));
					getc(fp);
				}
				fseek(fp,inf.Espblanco,SEEK_CUR);
			}
		}
		else
		{
			fprintf(stderr," > No puedo leer BMP con paletas de colores\n\r");
			destruye();
			fclose(fp);
			return 0;
		}
		fclose(fp);
		return inf.bits;
	}

	bool grabaBMP(const char *nombre, short nb=24)
	{
		FILE *fp;
		L_BMPheaderInfo inf;
		int i, j;
		struct {unsigned int b:5;unsigned int g:5;unsigned int r:5;unsigned int z:1;} rgb16;

		fp=fopen(nombre,"wb");
		if (fp==NULL)
			return false;
		inf.fijaTam(lx, ly, nb);
		inf.guardaEn(fp);
		fseek(fp, inf._offsetDatos, SEEK_SET);
		if (inf.bits==16)
		{
			for (j=ly-1; j>=0; j--)
			{
				for (i=0; i<lx; i++)
				{
					rgb16.r=pix[i][j][0];
					rgb16.g=pix[i][j][1];
					rgb16.b=pix[i][j][2];
					rgb16.z=0;
					fwrite(&rgb16,sizeof(rgb16),1,fp);
				}
				for (i=0; i<inf.Espblanco; i++)
					putc(0, fp);
				//fseek(fp,inf.Espblanco,SEEK_CUR);
			}
		}
		else if (inf.bits==24)
		{
			for (j=ly-1; j>=0; j--)
			{
				for (i=0; i<lx; i++)
				{
					putc(pix[i][j][2],fp);
					putc(pix[i][j][1],fp);
					putc(pix[i][j][0],fp);
				}
				for (i=0; i<inf.Espblanco; i++)
					putc(0, fp);
				//fseek(fp,inf.Espblanco,SEEK_CUR);
			}
		}
		else if (inf.bits==32)
		{
			for (j=ly-1; j>=0; j--)
			{
				for (i=0; i<lx; i++)
				{
					putc(pix[i][j][2],fp);
					putc(pix[i][j][1],fp);
					putc(pix[i][j][0],fp);
					putc(0,fp);
				}
				for (i=0; i<inf.Espblanco; i++)
					putc(0, fp);
				//fseek(fp,inf.Espblanco,SEEK_CUR);
			}
		}
		else
		{
			fprintf(stderr,"Problemas con nb al grabar BMP\n");
			return false;
		}
		fclose(fp);
		return true;
	}

	void destruye()
	{
		if (pix!=NULL)
		{
			L_delete3d<int>(pix);
		}
		pix=NULL;
	}
	~ImagenRGB() {destruye();} // Se llama automaticamente cuando se destruye el objeto
};

// Clase para imagen en blanco y negro
class ImagenBN
{
public:
	int ** pix;
	int lx;
	int ly;

	static int calcGris(int r, int g, int b) {return (int)( r*0.299 + g*0.511 + b*0.114 );}

	ImagenBN() {this->pix=NULL; lx=0; ly=0;}
	ImagenBN(int lx, int ly)
	{
		this->pix=NULL;
		reconstruye(lx, ly);
	}

	ImagenBN(const char *nombreArchivo)
	{
		leeBMP(nombreArchivo);
	}

	void reconstruye(int lx, int ly)
	{
		this->lx=lx;
		this->ly=ly;
		if (this->pix!=NULL)
			L_delete2d<int>(pix);
		this->pix=L_new2d<int>(lx,ly);
	}
	bool leeBMP(const char *nombre)
	{
		int i, j;
		ImagenRGB imRGB;
		imRGB.leeBMP(nombre);
		reconstruye(imRGB.lx,imRGB.ly);
		for (i=0; i<lx; i++)
		{
			for (j=0; j<ly; j++)
			{
				pix[i][j]=calcGris(imRGB.pix[i][j][0],imRGB.pix[i][j][1],imRGB.pix[i][j][2]);
			}
		}
	}
	bool grabaBMP(const char *nombre, short nb=24)
	{
		int i, j;
		ImagenRGB imRGB;
		imRGB.reconstruye(lx,ly);
		for (i=0; i<lx; i++)
		{
			for (j=0; j<ly; j++)
			{
				imRGB.pix[i][j][0]=pix[i][j];
				imRGB.pix[i][j][1]=pix[i][j];
				imRGB.pix[i][j][2]=pix[i][j];
			}
		}
		imRGB.grabaBMP(nombre,24);
	}
	void destruye()
	{
		L_delete2d<int>(pix);
		pix=NULL;
	}
	~ImagenBN() {destruye();} // Se llama automaticamente cuando se destruye el objeto
};



////////////////////////////
// Ahora el programa de ejemplo. Todo lo anterior es para poder definir como trabajar con imagenes.
void main(int argc, char *args[])
{
	int i, j;
	ImagenRGB im("mono.bmp");
	ImagenRGB im2(im.lx, im.ly);

	// Ejemplo: Copiar slo canalazul
	for (i=0; i<im.lx; i++)
	{
		for (j=0; j<im.ly; j++)
		{
			im2.pix[i][j][0]=0; // color rojo se deja en "negro"
			im2.pix[i][j][1]=0; // color verde se deja en "negro"
			im2.pix[i][j][2]=im.pix[i][j][2]; // color azul se copia
		}
	}

	im2.grabaBMP("mono2.bmp");

	ImagenBN im3(im.lx, im.ly);

	// Ejemplo: pasar una imagen a blanco y negro
	for (i=0; i<im.lx; i++)
	{
		for (j=0; j<im.ly; j++)
		{
			im3.pix[i][j]=ImagenBN::calcGris(im.pix[i][j][0],im.pix[i][j][1],im.pix[i][j][2]);
		}
	}

	ImagenBN im4(im.lx, im.ly);

	// Ejemplo: Negativo de una imagen en blanco y negro
	for (i=0; i<im.lx; i++)
	{
		for (j=0; j<im.ly; j++)
		{
			im4.pix[i][j]=255 - im3.pix[i][j];
		}
	}

	im4.grabaBMP("mono3.bmp");
	return;
}



