import java.io.*; // Para que encuentre File
import java.awt.image.*; // Para que encuentre BufferedImage
import javax.imageio.*; // para que encuentre ImageIO


public class EjemploJava
{
	public static void main(String[] args) throws IOException
	{
		File infile = new File("mono.jpg");
		BufferedImage im = ImageIO.read(infile);
		int rgb;
		int r, g, b;

		BufferedImage im2=new BufferedImage(im.getWidth(), im.getHeight(), BufferedImage.TYPE_INT_RGB); // nueva imagen RGB

		int i, j;
		for (i=0; i<im.getWidth(); i++)
		{
			for (j=0; j<im.getHeight(); j++)
			{
				rgb=im.getRGB(i,j); // color RGB mezclado: R:bits 16-23, B:bits 8-15, B:bits 0-7

				// Ahora, separar las componentes
          		r=(rgb/256/256)&255;//bits 16-23. El &255 deja los ultimos 8 bits.
          		g=(rgb/256)&255; //bits 8-15
          		b=rgb&255;      //bits 0-7

				r=0; // color rojo se deja en "negro"
          		g=0; // color verde se deja en "negro"
          		b=b; // color azul se copia

          		rgb=r*256*256+g*256+b; // Volver a mezclar las componentes
          		im2.setRGB(i,j,rgb);
			}
		}
		File outfile = new File("mono2.jpg");
		ImageIO.write(im2, "jpg", outfile);

		BufferedImage im3=new BufferedImage(im.getWidth(), im.getHeight(), BufferedImage.TYPE_INT_RGB); // nueva imagen RGB

		int gris;

		for (i=0; i<im.getWidth(); i++)
		{
			for (j=0; j<im.getHeight(); j++)
			{
				rgb=im.getRGB(i,j); // color RGB mezclado: R:bits 16-23, B:bits 8-15, B:bits 0-7

				// Ahora, separar las componentes
          		r=(rgb/256/256)&255;//bits 16-23. El &255 deja los ultimos 8 bits.
          		g=(rgb/256)&255; //bits 8-15
          		b=rgb&255;      //bits 0-7

          		gris=(int)( r*0.299 + g*0.511 + b*0.114 ); // Forma simple de transformar a gris

          		// Ahora se trabaja solo con el gris
				gris=255-gris; // Se invierte la imagen en blanco y negro

				r=gris;
          		g=gris;
          		b=gris;

          		rgb=r*256*256+g*256+b; // Volver a mezclar las componentes
          		im3.setRGB(i,j,rgb);
			}
		}
		outfile = new File("mono3.jpg");
		ImageIO.write(im3, "jpg", outfile);

		return;
	}
}



